;===================================================================
;                   ENCODE.ASM
;===================================================================
         EXTRN  NEWLINE:FAR
         EXTRN  PUTSTRNG:FAR
		 EXTRN	PUTBIN:FAR
         EXTRN  PARITY:FAR
;===================================================================
        .MODEL  SMALL, BASIC
        .STACK  256
;===================================================================
; D A T A   S E G M E N T   D E F I N I T I O N
        .DATA
TEMP			DW	?
ENCODEDNUM		DW  ?
ENCODING		DB  'ENCODING . . . .'
ENCDISPLAY		DB 	'Number in binary (data bits set in place): '

;===================================================================
; C O D E   S E G M E N T   D E F I N I T I O N
        .CODE
        ASSUME  DS:DGROUP
;===================================================================

ENCODE    PROC


        MOV		ENCODEDNUM, 0
		MOV		TEMP, AX
		MOV		BL, 1
		LEA		DI, ENCODING
		MOV		CX, SIZEOF ENCODING
		CALL	NEWLINE
        CALL    NEWLINE
		CALL	PUTSTRNG
		
SETDATA:		
		AND		AX, 00000000111B
		ADD		ENCODEDNUM, AX
		MOV		AX, TEMP
		AND		AX, 00000111000B
		SHL		AX, 1
		ADD		ENCODEDNUM, AX
		MOV		AX, TEMP
		AND		AX, 00001000000B
		MOV		CL, 2
		SHL		AX, CL
		ADD		ENCODEDNUM, AX
		MOV		AX, ENCODEDNUM
        CALL    NEWLINE
        LEA     DI, ENCDISPLAY
        MOV     CX, SIZEOF ENCDISPLAY
		CALL	PUTSTRNG
		CALL	PUTBIN
		
DO_ENCODE:		
		AND		AX, 1111B
		CALL	PARITY
		AND		AX, 0001B
		MOV		CL, 3
		SHL		AX, CL
		ADD		ENCODEDNUM, AX
		MOV		AX, ENCODEDNUM
		AND		AX, 00011110000B
		CALL	PARITY
		AND		AX, 0001B
		MOV		CL, 7
		SHL 	AX, CL
		ADD		ENCODEDNUM, AX
		MOV		AX, ENCODEDNUM
		AND		AX, 01100110011B
		CALL	PARITY
		AND		AX, 0001B
		MOV		CL, 9
		SHL 	AX, CL
		ADD		ENCODEDNUM, AX
		MOV		AX, ENCODEDNUM
		AND		AX, 0001B
		MOV		CL, 10
		SHL		AX, CL
		ADD		ENCODEDNUM, AX
		MOV		AX, ENCODEDNUM
		RET
				
ENCODE  ENDP
        END ENCODE       