;===================================================================
;                   DECODE.ASM
;===================================================================
         EXTRN  GETDEC$:FAR
         EXTRN  NEWLINE:FAR
         EXTRN  PUTSTRNG:FAR
         EXTRN  PUTDEC$:FAR
		 EXTRN	PUTBIN:FAR
		 EXTRN	PUTOCT:FAR
		 EXTRN	PAUSE:FAR
		 EXTRN 	ENCODE:FAR
         EXTRN  PARITY:FAR
;===================================================================
        .MODEL  SMALL, BASIC
        .STACK  256
;===================================================================
; D A T A   S E G M E N T   D E F I N I T I O N
        .DATA
TEMP			DW	?
BADBIT			DW 	?
TOGGLE			DW 	?
DATABITS		DW 	?
AUTHOR			DB  'Programmed By Adam Voliva.'
PROMPT			DB 	'Enter a number: '
BINDISPLAY		DB 	'Number in binary: '
CPKTDISPLAY		DB 	'Corrected packet in binary: '
PKTOCTDISPLAY 	DB 	'Corrected packet in octal: '
OCTDISPLAY		DB 	'Number in octal: '
BADDISPLAY		DB 	'Bad bit is: '

;===================================================================
; C O D E   S E G M E N T   D E F I N I T I O N
        .CODE
        ASSUME  DS:DGROUP
;===================================================================

MAIN    PROC

        MOV     AX,DGROUP           ;SET DS-REGISTER TO POINT TO
        MOV     DS,AX               ;DATA SEGMENT
        MOV     ES,AX               ;AND ES ALSO
		MOV		TEMP, 0
		MOV		BADBIT, 0
		MOV		TOGGLE, 0001B
		MOV		DATABITS, 0
		MOV		BL, 1
        CALL    NEWLINE
        LEA		DI, PROMPT
        MOV     CX, SIZEOF PROMPT
        CALL    PUTSTRNG
        CALL    GETDEC$
        MOV		TEMP, AX
		CALL	NEWLINE
		LEA		DI, OCTDISPLAY
		MOV		CX, SIZEOF OCTDISPLAY
		CALL	PUTSTRNG
		CALL	PUTOCT
        CALL    NEWLINE
        LEA     DI, BINDISPLAY
        MOV     CX, SIZEOF BINDISPLAY
        CALL    PUTSTRNG
		CALL	PUTBIN
		
MASKGRPS:
		AND 	AX, 00000001111B
		CALL	PARITY
		AND		AX, 0001B
		.IF		AX == 1
		ADD		BADBIT, 1000B
		.ENDIF
		MOV		AX, TEMP
		AND		AX, 00011110000B
		CALL	PARITY
		AND		AX, 0001B
		.IF		AX == 1
		ADD		BADBIT, 0100B
		.ENDIF
		MOV		AX, TEMP
		AND		AX, 01100110011B
		CALL	PARITY
		AND		AX, 0001B
		.IF		AX == 1
		ADD		BADBIT, 0010B
		.ENDIF
		MOV		AX, TEMP
		AND		AX, 10101010101B
		CALL	PARITY
		AND		AX, 0001B
		.IF		AX == 1
		ADD		BADBIT, 0001B
		.ENDIF

PRINTBIT:	
		MOV		AX, BADBIT
		.IF		AX > 0000B
		MOV		AX, 11
		SUB		AX, BADBIT
		MOV		CX, AX
		MOV		AX, TOGGLE
		SHL		AX, CL
		MOV		TOGGLE, AX
		MOV		AX, TEMP
		XOR		AX, TOGGLE
		MOV		TEMP, AX
		.ENDIF
		CALL	NEWLINE
		CALL	NEWLINE
		LEA		DI, BADDISPLAY
		MOV		CX, SIZEOF BADDISPLAY
		CALL	PUTSTRNG
		MOV		AX, BADBIT
		CALL	PUTDEC$
		CALL	NEWLINE
		MOV		AX, TEMP
		LEA		DI, CPKTDISPLAY
		MOV		CX, SIZEOF CPKTDISPLAY
		CALL	PUTSTRNG
		CALL	PUTBIN
		MOV		AX, TEMP
		CALL	ENCODE
		
CORRECT:
		AND		AX, 00000000111B
		ADD		DATABITS, AX
		MOV		AX, TEMP
		SHR		AX, 1
		AND		AX, 00000111000B
		ADD		DATABITS, AX
		MOV		AX, TEMP
		MOV		CL, 2
		SHR		AX, CL
		AND		AX, 00001000000B
		ADD		DATABITS, AX
		MOV		AX, DATABITS
		
PRINT:		
		CALL    NEWLINE
		CALL	NEWLINE
		CALL	NEWLINE
		LEA     DI, PKTOCTDISPLAY
        MOV     CX, SIZEOF PKTOCTDISPLAY
        CALL    PUTSTRNG
		CALL	PUTOCT
		
QUIT:	
		LEA     DI, AUTHOR
        MOV     CX, SIZEOF AUTHOR
		CALL	NEWLINE
		CALL 	NEWLINE
		CALL	PUTSTRNG
		SUB		CX, CX 				;If you don't do this, AUTHOR will be printed twice.
		CALL	PAUSE
		.EXIT
        MOV     AX, 4C00H
        INT     21H
MAIN    ENDP
        END MAIN        		